Leetcode 3 : C++ Longest Substring Without Repeating Characters

题目描述

此题考查的是:哈希表 双指针 与窗口滑动。

英文:

Given a string, find the length of the longest substring without repeating characters.
Example 1:
Input: “abcabcbb”
Output: 3
Explanation: The answer is “abc”, with the length of 3.
Example 2:
Input: “bbbbb”
Output: 1
Explanation: The answer is “b”, with the length of 1.
Example 3:
Input: “pwwkew”
Output: 3
Explanation: The answer is “wke”, with the length of 3.
Note that the answer must be a substring, “pwke” is a subsequence and not a substring.]

中文

给定一个字符串,请你找出其中不含有重复字符的 最长子串 的长度。

示例 1:

输入: “abcabcbb”
输出: 3
解释: 因为无重复字符的最长子串是 “abc”,所以其长度为 3。
示例 2:

输入: “bbbbb”
输出: 1
解释: 因为无重复字符的最长子串是 “b”,所以其长度为 1。
示例 3:

输入: “pwwkew”
输出: 3
解释: 因为无重复字符的最长子串是 “wke”,所以其长度为 3。
请注意,你的答案必须是 子串 的长度,“pwke” 是一个子序列,不是子串。

画图解析:

利用双指针 firstlast 来进行窗口滑动 用 map 来记住last滑过每个字符的索引,当last往后滑动时,遇到 map 里面的重复字符时,将first指针往后滑到重复字符的后面一个。每次循环返回最大的lengthlast++

在这里插入图片描述

My Solution : C++代码:

#include<iostream>
#include<algorithm>
#include<map>
#include<string>
using namespace std;

class Solution 
{
public:
    int lengthOfLongestSubstring(string s) 
    {
        int n = s.size();
        map <char,int> s_map;
        int first = 0;
        int last = 0;
        int len = 0;
        int result = 0;
        while(last<n)
        {
            char tmp = s[last];
            if(s_map.find(tmp)!= s_map.end() && s_map[tmp]>=first)
            {
                first = s_map[tmp] + 1;
                len = last - first;
            }
            s_map[tmp] = last;
            last++;
            len = last - first;
            result = max(result,len);
        }
        return result;
    }
};


int main()
{
    Solution s;
    string x = "aabca";
    int y = s.lengthOfLongestSubstring(x);
    cout<<y<<endl;
    system("pause");
    return 0;
}

个人的方法使用到了STL里面的 map 来即 hashmap记录索引来优化。但是我在网上找到了一种令我跟为惊艳的算法,用vector 用来当作 dictionary 来使用,代码如下:

Wonderful Idea

class Solution {
public:
    int lengthOfLongestSubstring(string s) {
        vector<int>m(256,-1);
        int left=-1;
        int res=0;
        int len=s.size();
        for(int i=0;i<len;i++)
        {
            left=max(left,m[s[i]]);
            m[s[i]]=i;
            res=max(res,i-left);
        }
        
        return res;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值